<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" /><link rel="canonical" href="https://example.com/best-practices/" />
      <link rel="shortcut icon" href="../img/favicon.ico" />
    <title>Best practices - ELIXIR Beacon v2 Network Documentation</title>
    <link rel="stylesheet" href="../css/theme.css" />
    <link rel="stylesheet" href="../css/theme_extra.css" />
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/styles/github.min.css" />
    
      <script>
        // Current page data
        var mkdocs_page_name = "Best practices";
        var mkdocs_page_input_path = "best-practices.md";
        var mkdocs_page_url = "/best-practices/";
      </script>
    
    <script src="../js/jquery-3.6.0.min.js" defer></script>
    <!--[if lt IE 9]>
      <script src="../js/html5shiv.min.js"></script>
    <![endif]-->
      <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/10.5.0/highlight.min.js"></script>
      <script>hljs.initHighlightingOnLoad();</script> 
</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side stickynav">
    <div class="wy-side-scroll">
      <div class="wy-side-nav-search">
          <a href=".." class="icon icon-home"> ELIXIR Beacon v2 Network Documentation
        </a><div role="search">
  <form id ="rtd-search-form" class="wy-form" action="../search.html" method="get">
      <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" title="Type search term here" />
  </form>
</div>
      </div>

      <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="..">Home</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../light-beacon-network/">Light a Beacon Network</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../beacon-aggregator/">Aggregator</a>
                </li>
              </ul>
              <ul>
                <li class="toctree-l1"><a class="reference internal" href="../beacon-registry/">Registry</a>
                </li>
              </ul>
              <ul class="current">
                <li class="toctree-l1 current"><a class="reference internal current" href="./">Best practices</a>
    <ul class="current">
    <li class="toctree-l2"><a class="reference internal" href="#adding-your-own-filters">Adding your own filters</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#synonyms">Synonyms</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#list-of-filtering-terms-constrained">List of filtering terms constrained</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#types-of-beacon-network">Types of Beacon Network</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#bn-opaque">BN Opaque</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#bn-transparent">BN Transparent</a>
    </li>
        </ul>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#user-certificates">User certificates</a>
    </li>
    <li class="toctree-l2"><a class="reference internal" href="#known-issues">Known issues</a>
        <ul>
    <li class="toctree-l3"><a class="reference internal" href="#query-per-second">Query per second</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#filtering-terms-endpoint">Filtering terms endpoint</a>
    </li>
    <li class="toctree-l3"><a class="reference internal" href="#correct-paths">Correct paths</a>
    </li>
        </ul>
    </li>
    </ul>
                </li>
              </ul>
      </div>
    </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">
      <nav class="wy-nav-top" role="navigation" aria-label="Mobile navigation menu">
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="..">ELIXIR Beacon v2 Network Documentation</a>
        
      </nav>
      <div class="wy-nav-content">
        <div class="rst-content"><div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href=".." class="icon icon-home" aria-label="Docs"></a> &raquo;</li>
      <li>Best practices</li>
    <li class="wy-breadcrumbs-aside">
    </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
            <div class="section" itemprop="articleBody">
              
                <h1 id="best-practices">Best Practices</h1>
<h2 id="adding-your-own-filters">Adding your own filters</h2>
<h3 id="synonyms">Synonyms</h3>
<p>In a network of multiple instances of Beacon, probably you will find different ontologies for the same concepts. The best way to deal with that is to put the relationships between the ontologies configuration.</p>
<p>This feature is yet to develop in the ELIXIR Beacon v2 Network instance.</p>
<h3 id="list-of-filtering-terms-constrained">List of filtering terms constrained</h3>
<p>You decide which filtering terms a BN can query. You can avoid all the filtering terms of all the Beacons, and only use the ones from the static ontologies of the Aggregator.</p>
<h2 id="types-of-beacon-network">Types of Beacon Network</h2>
<h3 id="bn-opaque">BN Opaque</h3>
<p>This type of Beacon Network allows the user to query the data without knowing its origin. The user knows the data is present in the network but is unaware of which specific Beacon it comes from. This type is particularly useful for rare diseases or situations where identifying the data source is not necessary.</p>
<h3 id="bn-transparent">BN Transparent</h3>
<p>Type of Beacon Network where the source is known. When querying data, the BN will provide information about the Beacon holding that information. It will allow users to track the source of data and be able to ask for access to the full dataset, thus allowing data sharing.</p>
<h2 id="user-certificates">User certificates</h2>
<p>To ensure the privacy and anonymity of the data, a BN should keep track of the queries done by the users. As an example, a user can make multiple queries to retrieve all the genomic data of a patient. This can potentially compromise the privacy of the patient and confidentiality of the data.</p>
<p>To address the issue, Beacon Networks can use User Certificates to know who makes queries to the Beacons. By monitoring their activity we can prevent users from accessing too much data at once and identify suspicious activities. A possible solution is to limit the number of queries per user in a day or to stop giving access to a user when the queries are mistrustful.</p>
<p>This mechanism will build trust and confidence among users and data owners.</p>
<h2 id="known-issues">Known issues</h2>
<p>Here there are issues that we have found in different Beacons when importing them to the network:</p>
<h3 id="query-per-second">Query per second</h3>
<p>When the network fetches the Beacons, first it needs to query the metadata in order to parse and put it in the cache. These queries are done in consequential order. If one of your Beacons API has limited the queries per second, this would cause trouble to the Network as it won’t let it search for all the needed metadata.</p>
<h3 id="filtering-terms-endpoint">Filtering terms endpoint</h3>
<p>The scope of the filtering terms endpoint must be per schema.
MOLGENIS example (there is not a filtering term endpoint). There is only an endpoint for each individual (does not make sense)</p>
<h3 id="correct-paths">Correct paths</h3>
<p>Always check that the URLs in the /map endpoint are correct. Also, the rootUrl property in /map endpoint has to be the same URL as the Beacon. The same with the FilteringTerms endpoin, where the filtering terms should be for all or one schema, not for each individual.</p>
              
            </div>
          </div><footer>
    <div class="rst-footer-buttons" role="navigation" aria-label="Footer Navigation">
        <a href="../beacon-registry/" class="btn btn-neutral float-left" title="Registry"><span class="icon icon-circle-arrow-left"></span> Previous</a>
    </div>

  <hr/>

  <div role="contentinfo">
    <!-- Copyright etc -->
  </div>

  Built with <a href="https://www.mkdocs.org/">MkDocs</a> using a <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>.
</footer>
          
        </div>
      </div>

    </section>

  </div>

  <div class="rst-versions" role="note" aria-label="Versions">
  <span class="rst-current-version" data-toggle="rst-current-version">
    
    
      <span><a href="../beacon-registry/" style="color: #fcfcfc">&laquo; Previous</a></span>
    
    
  </span>
</div>
    <script>var base_url = '..';</script>
    <script src="../js/theme_extra.js" defer></script>
    <script src="../js/theme.js" defer></script>
      <script src="../search/main.js" defer></script>
    <script defer>
        window.onload = function () {
            SphinxRtdTheme.Navigation.enable(true);
        };
    </script>

</body>
</html>
